<?php

/*
Plugin Name: Also LJ Avatar
Plugin URI: http://alltrees.org/Wordpress/
Description: This plugin works on top of the WP native Gravatar function. If a commenter  has an LJ-clone account, commenting with username@service in the Name field will retrieve their default icon.  If they are logged in with OpenID, using an LJ-clone account, that will also work.  If none of these is true, the native Gravatar function will go on as normal. CHECK FOR UPDATES MANUALLY.
Version: 2.3
Author: Emily Ravenwood and Ken Irwin. Icon-fetching code taken from Alexander Bishop's LJ or Gravatar plugin.
Author URI: http://alltrees.org
License: GPL (http://www.gnu.org/licenses/gpl.html)
*/


function dangaicon($avatar) {
	global $comment;
	
	//extract the height/width specified in the theme, if any, to use as size
	if ( preg_match("/height='([0-9]*)'/", $avatar, $m) || preg_match('/height="([0-9]*)"/', $avatar, $m) ) {
		$size = $m[1]; }
	else {
		$size = 80; }
	
	$dangas = array ("livejournal" => "livejournal.com",
								"insanejournal" => "insanejournal.com",
								"journalfen" => "journalfen.net",
								"deadjournal" => "deadjournal.com",
								"greatestjournal" => "greatestjournal.com",
								);
	
	//If user is logged in, fetch their url (to use OpenID profiles)
	$auth_url = get_comment_author_url();

	//If the url matches an LJ configuration, reformat the information and pass it to the next section in the form of a username@journal
	foreach ($dangas as $danga => $danga_url) {
		if (preg_match("/$danga_url/", $auth_url)) {
			$danga_journal=$danga;
			$danga_journal_url = $danga_url; 
			} //end if
		}//end foreach
	if ( preg_match("/http:\/\/(.*)\.$danga_journal_url\/([^\/]*)\/*/",$auth_url,$m) ) {
		if ($m[2]) {
			$comment->comment_author = $m[2] . "@$danga_journal";
		}
		elseif ($m[1]) {
			$comment->comment_author = $m[1] . "@$danga_journal";
		}
	 }	//endif
	
	//If the comment author is username@anything, extract the username to name the pic with locally
	if (preg_match("/@/", $comment->comment_author)) {
		$name = explode("@", $comment->comment_author);
		$danga_user = $name[0];
		//make sure the name is all lowercase
		$danga_user = strtolower($danga_user);
		
		foreach ($dangas as $danga => $danga_url) {
			if (preg_match("/$danga/", $name[1])) {
				$danga_journal=$danga;
				$danga_journal_url = $danga_url; 
				}//end if
			}//end foreach
		
		//and if the user is @livejournal et al, carry on
		if ( ($name[1] == "$danga_journal") || ($name[1] == "$danga_journal_url") )
		{
			//see if there is a pic cached under that username to use
			if (file_exists(ABSPATH.'/wp-content/plugins/also-lj-avatar/danga-icons/'.$danga_user) )
			{
				//package image in a variable for use in this if
				$pic = '/wp-content/plugins/also-lj-avatar/danga-icons/'.$danga_user;

				//subtract file creation time from current time and divide to get days
				$diff = (time() - filectime(ABSPATH . $pic))/60/60/24;
				//if the file is older than 30 days, and getpic has valid output, fetch it again and re-cache it
				if ( $diff > 30 ) {
					$getpic = getuserpic($danga_user,$danga_journal_url);
					if ($getpic != "") {
					 system("wget -O ". ABSPATH ."$pic $getpic");
					}
				}
								
				//now use it for output
				$out = '<img class="avatar" src='. get_settings("siteurl").$pic .' height="'. $size .'" width="'. $size .'" />';
				
			}//end if there is already an icon
			else 
			{
				//if not, use the function lower down to get it
				$pic = getuserpic($danga_user,$danga_journal_url);
				$out = '<img class="avatar" src='. $pic .' height="'. $size .'" width="'. $size .'" />';
				// and cache it in /danga-icons/ folder for future use, if there is anything on the other end.
				if ($getpic != "") {
					system("wget -O ". ABSPATH ."/wp-content/plugins/also-lj-avatar/danga-icons/$danga_user $pic");
				}
			}//endelse
		}//endif
	
		//If there is an LJ-clone icon to be had, render that as the avatar
		$avatar = $out;
	}//end if @ in commenter name

	//otherwise, carry on as normal
	else
	{
		$avatar = $avatar;
	}
	
	return $avatar;
	
}

//If the user parses as an LJ-clone user and does not have a pic cached, go get their default user icon (This code is by Alex Bishop)
function getuserpic($danga_user, $danga_journal_url)
{
	$needle = "_";
	$score = strpos($danga_user, $needle);
	
	if ( $danga_journal_url == "livejournal.com" && $score > 0 ) {
		$url = "http://$danga_user.$danga_journal_url/profile";
	}
	else {
	$url = "http://users.$danga_journal_url/$danga_user/profile/";
	}
	
	$userinfo = file_get_contents($url);

	$starttoken="http://www.$danga_journal_url/allpics.bml?user=".str_replace("-","_",$danga_user)."'><img src='";
	$endtoken="'";
	$start=strpos($userinfo,$starttoken)+strlen($starttoken);

	if($start>strlen($starttoken))
	{
		$end=strpos($userinfo,$endtoken,$start);
		return substr($userinfo,$start,$end-$start);
	}
}

add_filter ('get_avatar', 'dangaicon', 9999);
?>